#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <conio.h>

FILE *fp;
int hex_size;
#define MAXMEM 64*1024*1024
unsigned char membuf[MAXMEM];
unsigned char out_file[256];


void more_()
{
	printf("[ L[ĉ ]\n"); getch();
}

void zip_fixer(unsigned char *Filename , unsigned char *Filename2)
{
	int i,ad,hex_size;
	unsigned char d;
	FILE *fp;
	int error_flag=0;
	
	printf("--- Zipt@C̏CJn܂\n");
	
	fp=fopen((char *)Filename,"rb");
	strcpy((char *)out_file,(char *)Filename2);
	if (fp==NULL) {
		printf("Error: t@C܂\n");
		more_(); exit(1);
	}
	hex_size= filelength( fileno(fp) );
	if (hex_size > MAXMEM) {
		printf("Error: t@C傫߂ł (%d)\n",hex_size);
		fclose(fp); more_(); exit(1);
	}
	for (i=0;i<MAXMEM;i++) { membuf[i]=0x00; }
	fread( membuf , 1 , hex_size , fp );
	fclose(fp);
	
	ad=0;
	while (1) {
		unsigned char sig1,sig2,sig3,sig4;
		unsigned char ver1,ver2;
		unsigned char flg1,flg2;
		unsigned char mtd1,mtd2;
		unsigned char tim1,tim2;
		unsigned char dat1,dat2;
		unsigned char crc1,crc2,crc3,crc4;
		unsigned char csz1,csz2,csz3,csz4;
		unsigned char usz1,usz2,usz3,usz4;
		unsigned char len1,len2;
		unsigned char ext1,ext2;
		unsigned char atr1,atr2,atr3,atr4;
		int len;
		int exlen;
		int clen;
	
		
		sig1= membuf[ad+0];
		sig2= membuf[ad+1];
		sig3= membuf[ad+2];
		sig4= membuf[ad+3];
		if (sig1!='P') {
			if (ad!=hex_size) {
				error_flag=1;
			}
			break;
		}
		
		
		if ((sig3==0x03)&&(sig4==0x04)) {  // normal local header
			//printf("local header\n");
			ver1= membuf[ad+4];
			ver2= membuf[ad+5];
			flg1= membuf[ad+6];
			flg2= membuf[ad+7];
			mtd1= membuf[ad+8];
			mtd2= membuf[ad+9];
			tim1= membuf[ad+10];
			tim2= membuf[ad+11];
			dat1= membuf[ad+12];
			dat2= membuf[ad+13];
			crc1= membuf[ad+14];
			crc2= membuf[ad+15];
			crc3= membuf[ad+16];
			crc4= membuf[ad+17];
			csz1= membuf[ad+18];
			csz2= membuf[ad+19];
			csz3= membuf[ad+20];
			csz4= membuf[ad+21];
			clen=csz1+ csz2*256 + csz3*65536;
			usz1= membuf[ad+22];
			usz2= membuf[ad+23];
			usz3= membuf[ad+24];
			usz4= membuf[ad+25];
			len1= membuf[ad+26];
			len2= membuf[ad+27];
			len = len1 + len2*256;
			ext1= membuf[ad+28];
			ext2= membuf[ad+29];
			exlen = ext1 + ext2*256;
			
			//printf(" filename:");
			ad = ad + 30 + len + exlen + clen;
		
		
		} else if ((sig3==0x01)&&(sig4==0x02)) {  // central directory  header
		
			//printf("central directory\n");
			ver1= membuf[ad+4];
			ver2= membuf[ad+5];
			ver1= membuf[ad+6];
			ver2= membuf[ad+7];
			flg1= membuf[ad+8];
			flg2= membuf[ad+9];
			mtd1= membuf[ad+10];
			mtd2= membuf[ad+11];
			tim1= membuf[ad+12];
			tim2= membuf[ad+13];
			dat1= membuf[ad+14];
			dat2= membuf[ad+15];
			crc1= membuf[ad+16];
			crc2= membuf[ad+17];
			crc3= membuf[ad+18];
			crc4= membuf[ad+19];
			csz1= membuf[ad+20];
			csz2= membuf[ad+21];
			csz3= membuf[ad+22];
			csz4= membuf[ad+23];
			clen=csz1+ csz2*256 + csz3*65536;
			usz1= membuf[ad+24];
			usz2= membuf[ad+25];
			usz3= membuf[ad+26];
			usz4= membuf[ad+27];
			len1= membuf[ad+28];
			len2= membuf[ad+29];
			len = len1 + len2*256;
			ext1= membuf[ad+30];
			ext2= membuf[ad+31];
			exlen = ext1 + ext2*256;
			csz1= membuf[ad+32];
			csz2= membuf[ad+33];
			clen=csz1+ csz2*256;
			atr1= membuf[ad+36];
			atr2= membuf[ad+37];
			atr1= membuf[ad+38];
			atr2= membuf[ad+39];
			atr3= membuf[ad+40];
			atr4= membuf[ad+41];
			
			// S ATTR 0xED81ɏ
			membuf[ad+38]=0x00;
			membuf[ad+39]=0x00;
			membuf[ad+40]=0xED;
			membuf[ad+41]=0x81;
			
			
			//printf("\n");
			ad = ad + 46 + len + exlen + clen;
			
			
		} else if ((sig3==0x05)&&(sig4==0x06)) {  // end of  central directory  header
			//printf("end  of  central directory\n");
			csz1= membuf[ad+20];
			csz2= membuf[ad+21];
			clen=csz1+ csz2*256;
			//printf("\n");
			ad = ad + 22 + clen;
		
		} else {
			//printf("unknown header\n");
			//printf(" sig %02X,%02X,%02X,%02X\n",sig1,sig2,sig3,sig4);
			error_flag=1;
			break;
		
		}
	}
	
	if (error_flag==1) {
		printf("Error: zipt@Cُł (𒆒f܂)\n");
		more_();
	}
	
	fp=fopen((char *)out_file,"wb");
	for (i=0;i<hex_size;i++) {
		fprintf(fp,"%c",membuf[i]);
	}
	fclose(fp);
	
	printf("Zipt@CC܂\n");
}
